<template>
  <MediaResolver
    :src="properSrc"
    :mimeType="properType"
    poster="https://secretmag.ru/imgs/2021/03/25/13/4577947/1d79f694a1edc20101d5e8b348013c05d5799219.gif"
    preview />
</template>

<script lang="ts">
import { Component, Prop, Vue } from 'nuxt-property-decorator'
import { get, update } from 'idb-keyval'
import { NFTMetadata } from '../service/scheme'
import axios from 'axios'

const MediaResolver = () => import('./MediaResolver.vue')

@Component({
  components: {
    MediaResolver,
  },
})
export default class PreviewMediaResolver extends Vue {
  @Prop(String) public src!: string
  @Prop(String) public metadata!: string
  @Prop(String) public mimeType!: string
  protected type = ''

  created() {
    this.fetchMimeType()
  }

  get properType() {
    return this.mimeType || this.type || 'image/webp'
  }

  get properSrc() {
    return this.src || 'https://secretmag.ru/imgs/2021/03/25/13/4577947/1d79f694a1edc20101d5e8b348013c05d5799219.gif'
  }

  protected async fetchMimeType() {
    if (this.mimeType) {
      return
    }

    const m = await get<NFTMetadata>(this.metadata)
    this.type = m?.type || ''
    if (!this.type) {
      const { headers } = await axios.head(this.src)
      this.type = headers['content-type']
      update(this.metadata, (cached) => ({
        ...(cached || {}),
        type: this.type,
      }))
    }
  }
}
</script>
